<?php


use Kreait\Firebase\Factory;
use Kreait\Firebase\ServiceAccount;
use  Kreait\Firebase\Messaging\Notification;
use  Kreait\Firebase\Messaging\CloudMessage;
use Kreait\Firebase\Messaging\AndroidConfig;
use Kreait\Firebase\Exception\Messaging\InvalidMessage as msgInvalido;


class BroadcastPedidos  
{
    
    public function sendNotification()
    {
            $serviceAccount = ServiceAccount::fromJsonFile( dirname(__DIR__)."/sitexapp-firebase-adminsdk-ivsgf-74e5d53ef1.json");
            $firebase = ( new Factory )
                    ->withServiceAccount( $serviceAccount )
                    ->create();
        try{
            $notificacionHandler = $firebase->getMessaging();       

            $contendio = [
                'compra' => 'Ninguna',
                'id' => '',
                'fechaSolicitud' => '',
                'pedido' => []
            ];

            // Obteniendo los usuarios 
            $usuariosInternosController = new UsuariosInternosController;
            $tokensAlmacenes = $usuariosInternosController->getTokensAlmacenes();
            

            // obteniendo los traspasos en transito o cancelados de cada sucursal
            foreach ($tokensAlmacenes as $tokenAlmacen) {
                $pedidosController = new PedidosController;
                $listaPedidos = $pedidosController->getTraspasosAlmacen( $tokenAlmacen['almacen']);
                if ( sizeof( $listaPedidos ) ) {
                    $titulo ='';
                    $body = '';

                    foreach ($listaPedidos as $pedidos) {

                        foreach ( $pedidos as  $pedido) {
                            echo ( $pedido['almacen_origen'] ."==". $tokenAlmacen['almacen'] ."<br>");
                            echo ( $pedido['almacen_destino'] ."==". $tokenAlmacen['almacen'] ."<br><br>");
                        if ( $pedido['almacen_origen'] == $tokenAlmacen['almacen'] ) {
                            if ( $pedido['estado'] == 'Solicitado') {   
                                $titulo = "SOLICITUD DE TRASPASO RECIBIDA";
                                $body = "Por favor atiende tu buzón de pedidos en el eshop";

                            } elseif( $pedido['estado'] == 'Devuelto') {
                                $titulo = "TRASPASO DEVUELTO";
                                $body = "Por favor revisa tu buzón de pedidos en el eshop, para ver el detalle de la devolución";
                            }
                            
                        } else if(  $pedido['almacen_destino'] == $tokenAlmacen['almacen'] ) {
                            if ( $pedido['estado'] == 'En entrega') {
                                $titulo = "TRASPASO EN CAMINO";
                                $body = "Tu pedido ya se encuentra en transito, en breve podrás recepcionarlo";

                            } elseif( $pedido['estado'] == 'Cancelado') {
                                $titulo = "TU PEDIDO FUE CANCELADO";
                                $body = "Por favor revisa tú buzón de pedido para ver el motivo de la cancelación";
                            }                            
                        }
                        echo $titulo."<br>";
                        $config = AndroidConfig::fromArray([
                            'ttl' => '3600s',
                            'priority' => 'high',
                            'data' => $contendio,
                            'notification' => [
                                // 'android_channel_id' => "notificacionesOreo",
                                'title' => $titulo,
                                'body' => $body,
                                'color' => '#f45342',
                                "sound" => "notificacion",
                                'click_action' => 'BUZON_PEDIDOS_NOTIFICATION'
                            ],
                        ]);                                    

                        if ( $titulo != '' ) {
                            $contentNotificacion = CloudMessage::withTarget('token', $tokenAlmacen['token'])
                                                            ->withAndroidConfig( $config );
                            $notificacionHandler->send( $contentNotificacion);
                        }

                        }
                    }
                }

            }
        }catch (msgInvalido $error){

        }

    }

}


